Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -2388,90 +2368,89 @@
     DO j = minorig, nl
       DO il = 1, ncum
-        IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (j>=(icb(il)-1)) .AND. (j<=inb(il))) THEN
-
-          rti = qnk(il) - ep(il, i)*clw(il, i)
-          bf2 = 1. + lv(il, j)*lv(il, j)*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
-
+        IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (j>=(icb(il) - 1)) .AND. (j<=inb(il))) THEN
+
+          rti = qnk(il) - ep(il, i) * clw(il, i)
+          bf2 = 1. + lv(il, j) * lv(il, j) * rs(il, j) / (rrv * t(il, j) * t(il, j) * cpd)
 
           IF (cvflag_ice) THEN
-! PRINT*,cvflag_ice,'cvflag_ice dans do 700'
-            IF (t(il,j)<=263.15) THEN
-              bf2 = 1. + (lf(il,j)+lv(il,j))*(lv(il,j)+frac(il,j)* &
-                   lf(il,j))*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
+            ! PRINT*,cvflag_ice,'cvflag_ice dans do 700'
+            IF (t(il, j)<=263.15) THEN
+              bf2 = 1. + (lf(il, j) + lv(il, j)) * (lv(il, j) + frac(il, j) * &
+                      lf(il, j)) * rs(il, j) / (rrv * t(il, j) * t(il, j) * cpd)
             END IF
           END IF
 
-          anum = h(il, j) - hp(il, i) + (cpv-cpd)*t(il, j)*(rti-rr(il,j))
-          denom = h(il, i) - hp(il, i) + (cpd-cpv)*(rr(il,i)-rti)*t(il, j)
+          anum = h(il, j) - hp(il, i) + (cpv - cpd) * t(il, j) * (rti - rr(il, j))
+          denom = h(il, i) - hp(il, i) + (cpd - cpv) * (rr(il, i) - rti) * t(il, j)
           dei = denom
           IF (abs(dei)<0.01) dei = 0.01
-          sij(il, i, j) = anum/dei
+          sij(il, i, j) = anum / dei
           sij(il, i, i) = 1.0
-          altem = sij(il, i, j)*rr(il, i) + (1.-sij(il,i,j))*rti - rs(il, j)
-          altem = altem/bf2
-          cwat = clw(il, j)*(1.-ep(il,j))
+          altem = sij(il, i, j) * rr(il, i) + (1. - sij(il, i, j)) * rti - rs(il, j)
+          altem = altem / bf2
+          cwat = clw(il, j) * (1. - ep(il, j))
           stemp = sij(il, i, j)
           IF ((stemp<0.0 .OR. stemp>1.0 .OR. altem>cwat) .AND. j>i) THEN
 
             IF (cvflag_ice) THEN
-              anum = anum - (lv(il,j)+frac(il,j)*lf(il,j))*(rti-rs(il,j)-cwat*bf2)
-              denom = denom + (lv(il,j)+frac(il,j)*lf(il,j))*(rr(il,i)-rti)
+              anum = anum - (lv(il, j) + frac(il, j) * lf(il, j)) * (rti - rs(il, j) - cwat * bf2)
+              denom = denom + (lv(il, j) + frac(il, j) * lf(il, j)) * (rr(il, i) - rti)
             ELSE
-              anum = anum - lv(il, j)*(rti-rs(il,j)-cwat*bf2)
-              denom = denom + lv(il, j)*(rr(il,i)-rti)
+              anum = anum - lv(il, j) * (rti - rs(il, j) - cwat * bf2)
+              denom = denom + lv(il, j) * (rr(il, i) - rti)
             END IF
 
             IF (abs(denom)<0.01) denom = 0.01
-            sij(il, i, j) = anum/denom
-            altem = sij(il, i, j)*rr(il, i) + (1.-sij(il,i,j))*rti - rs(il, j)
-            altem = altem - (bf2-1.)*cwat
+            sij(il, i, j) = anum / denom
+            altem = sij(il, i, j) * rr(il, i) + (1. - sij(il, i, j)) * rti - rs(il, j)
+            altem = altem - (bf2 - 1.) * cwat
           END IF
-          IF (sij(il,i,j)>0.0 .AND. sij(il,i,j)<0.95) THEN
-            qent(il, i, j) = sij(il, i, j)*rr(il, i) + (1.-sij(il,i,j))*rti
-            uent(il, i, j) = sij(il, i, j)*u(il, i) + (1.-sij(il,i,j))*unk(il)
-            vent(il, i, j) = sij(il, i, j)*v(il, i) + (1.-sij(il,i,j))*vnk(il)
-!!!!      do k=1,ntra
-!!!!      traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
-!!!!     :      +(1.-sij(il,i,j))*tra(il,nk(il),k)
-!!!!      END DO
+          IF (sij(il, i, j)>0.0 .AND. sij(il, i, j)<0.95) THEN
+            qent(il, i, j) = sij(il, i, j) * rr(il, i) + (1. - sij(il, i, j)) * rti
+            uent(il, i, j) = sij(il, i, j) * u(il, i) + (1. - sij(il, i, j)) * unk(il)
+            vent(il, i, j) = sij(il, i, j) * v(il, i) + (1. - sij(il, i, j)) * vnk(il)
+            !!!!      do k=1,ntra
+            !!!!      traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
+            !!!!     :      +(1.-sij(il,i,j))*tra(il,nk(il),k)
+            !!!!      END DO
             elij(il, i, j) = altem
-            elij(il, i, j) = max(0.0, elij(il,i,j))
-            ment(il, i, j) = m(il, i)/(1.-sij(il,i,j))
+            elij(il, i, j) = max(0.0, elij(il, i, j))
+            ment(il, i, j) = m(il, i) / (1. - sij(il, i, j))
             nent(il, i) = nent(il, i) + 1
           END IF
-          sij(il, i, j) = max(0.0, sij(il,i,j))
-          sij(il, i, j) = amin1(1.0, sij(il,i,j))
+          sij(il, i, j) = max(0.0, sij(il, i, j))
+          sij(il, i, j) = amin1(1.0, sij(il, i, j))
         END IF ! new
       END DO
     END DO
 
-!AC!       do k=1,ntra
-!AC!        do j=minorig,nl
-!AC!         do il=1,ncum
-!AC!          IF( (i.ge.icb(il)).AND.(i.le.inb(il)).AND.
-!AC!     :       (j.ge.(icb(il)-1)).AND.(j.le.inb(il)))THEN
-!AC!            traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
-!AC!     :            +(1.-sij(il,i,j))*tra(il,nk(il),k)
-!AC!          endif
-!AC!         enddo
-!AC!        enddo
-!AC!       enddo
-
-
-! ***   if no air can entrain at level i assume that updraft detrains  ***
-! ***   at that level and calculate detrained air flux and properties  ***
-
-
-! @      do 170 i=icb(il),inb(il)
+    !AC!       do k=1,ntra
+    !AC!        do j=minorig,nl
+    !AC!         do il=1,ncum
+    !AC!          IF( (i.ge.icb(il)).AND.(i.le.inb(il)).AND.
+    !AC!     :       (j.ge.(icb(il)-1)).AND.(j.le.inb(il)))THEN
+    !AC!            traent(il,i,j,k)=sij(il,i,j)*tra(il,i,k)
+    !AC!     :            +(1.-sij(il,i,j))*tra(il,nk(il),k)
+    !AC!          endif
+    !AC!         enddo
+    !AC!        enddo
+    !AC!       enddo
+
+
+    ! ***   if no air can entrain at level i assume that updraft detrains  ***
+    ! ***   at that level and calculate detrained air flux and properties  ***
+
+
+    ! @      do 170 i=icb(il),inb(il)
 
     DO il = 1, ncum
-      IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (nent(il,i)==0)) THEN
-! @      IF(nent(il,i).EQ.0)THEN
+      IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (nent(il, i)==0)) THEN
+        ! @      IF(nent(il,i).EQ.0)THEN
         ment(il, i, i) = m(il, i)
-        qent(il, i, i) = qnk(il) - ep(il, i)*clw(il, i)
+        qent(il, i, i) = qnk(il) - ep(il, i) * clw(il, i)
         uent(il, i, i) = unk(il)
         vent(il, i, i) = vnk(il)
         elij(il, i, i) = clw(il, i)
-! MAF      sij(il,i,i)=1.0
+        ! MAF      sij(il,i,i)=1.0
         sij(il, i, i) = 0.0
       END IF
@@ -2479,18 +2458,18 @@
   END DO
 
-!AC!      do j=1,ntra
-!AC!       do i=minorig+1,nl
-!AC!        do il=1,ncum
-!AC!         if (i.ge.icb(il) .AND. i.le.inb(il) .AND. nent(il,i).EQ.0) THEN
-!AC!          traent(il,i,i,j)=tra(il,nk(il),j)
-!AC!         endif
-!AC!        enddo
-!AC!       enddo
-!AC!      enddo
+  !AC!      do j=1,ntra
+  !AC!       do i=minorig+1,nl
+  !AC!        do il=1,ncum
+  !AC!         if (i.ge.icb(il) .AND. i.le.inb(il) .AND. nent(il,i).EQ.0) THEN
+  !AC!          traent(il,i,i,j)=tra(il,nk(il),j)
+  !AC!         endif
+  !AC!        enddo
+  !AC!       enddo
+  !AC!      enddo
 
   DO j = minorig, nl
     DO i = minorig, nl
       DO il = 1, ncum
-        IF ((j>=(icb(il)-1)) .AND. (j<=inb(il)) .AND. (i>=icb(il)) .AND. (i<=inb(il))) THEN
+        IF ((j>=(icb(il) - 1)) .AND. (j<=inb(il)) .AND. (i>=icb(il)) .AND. (i<=inb(il))) THEN
           sigij(il, i, j) = sij(il, i, j)
         END IF
@@ -2498,16 +2477,16 @@
     END DO
   END DO
-! @      enddo
-
-! @170   continue
-
-! =====================================================================
-! ---  NORMALIZE ENTRAINED AIR MASS FLUXES
-! ---  TO REPRESENT EQUAL PROBABILITIES OF MIXING
-! =====================================================================
-
-  CALL zilch(asum, nloc*nd)
-  CALL zilch(csum, nloc*nd)
-  CALL zilch(csum, nloc*nd)
+  ! @      enddo
+
+  ! @170   continue
+
+  ! =====================================================================
+  ! ---  NORMALIZE ENTRAINED AIR MASS FLUXES
+  ! ---  TO REPRESENT EQUAL PROBABILITIES OF MIXING
+  ! =====================================================================
+
+  CALL zilch(asum, nloc * nd)
+  CALL zilch(csum, nloc * nd)
+  CALL zilch(csum, nloc * nd)
 
   DO il = 1, ncum
@@ -2523,27 +2502,26 @@
     IF (num1<=0) GO TO 789
 
-
     DO il = 1, ncum
       IF (i>=icb(il) .AND. i<=inb(il)) THEN
-        lwork(il) = (nent(il,i)/=0)
-        qp = qnk(il) - ep(il, i)*clw(il, i)
+        lwork(il) = (nent(il, i)/=0)
+        qp = qnk(il) - ep(il, i) * clw(il, i)
 
         IF (cvflag_ice) THEN
 
-          anum = h(il, i) - hp(il, i) - (lv(il,i)+frac(il,i)*lf(il,i))* &
-                       (qp-rs(il,i)) + (cpv-cpd)*t(il, i)*(qp-rr(il,i))
-          denom = h(il, i) - hp(il, i) + (lv(il,i)+frac(il,i)*lf(il,i))* &
-                       (rr(il,i)-qp) + (cpd-cpv)*t(il, i)*(rr(il,i)-qp)
+          anum = h(il, i) - hp(il, i) - (lv(il, i) + frac(il, i) * lf(il, i)) * &
+                  (qp - rs(il, i)) + (cpv - cpd) * t(il, i) * (qp - rr(il, i))
+          denom = h(il, i) - hp(il, i) + (lv(il, i) + frac(il, i) * lf(il, i)) * &
+                  (rr(il, i) - qp) + (cpd - cpv) * t(il, i) * (rr(il, i) - qp)
         ELSE
 
-          anum = h(il, i) - hp(il, i) - lv(il, i)*(qp-rs(il,i)) + &
-                       (cpv-cpd)*t(il, i)*(qp-rr(il,i))
-          denom = h(il, i) - hp(il, i) + lv(il, i)*(rr(il,i)-qp) + &
-                       (cpd-cpv)*t(il, i)*(rr(il,i)-qp)
+          anum = h(il, i) - hp(il, i) - lv(il, i) * (qp - rs(il, i)) + &
+                  (cpv - cpd) * t(il, i) * (qp - rr(il, i))
+          denom = h(il, i) - hp(il, i) + lv(il, i) * (rr(il, i) - qp) + &
+                  (cpd - cpv) * t(il, i) * (rr(il, i) - qp)
         END IF
 
         IF (abs(denom)<0.01) denom = 0.01
-        scrit(il) = anum/denom
-        alt = qp - rs(il, i) + scrit(il)*(rr(il,i)-qp)
+        scrit(il) = anum / denom
+        alt = qp - rs(il, i) + scrit(il) * (rr(il, i) - qp)
         IF (scrit(il)<=0.0 .OR. alt<=0.0) scrit(il) = 1.0
         smax(il) = 0.0
@@ -2557,6 +2535,6 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il) .AND. &
-            lwork(il)) num2 = num2 + 1
+                j>=(icb(il) - 1) .AND. j<=inb(il) .AND. &
+                lwork(il)) num2 = num2 + 1
       END DO
       IF (num2<=0) GO TO 175
@@ -2564,38 +2542,38 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il) .AND. &
-            lwork(il)) THEN
-
-          IF (sij(il,i,j)>1.0E-16 .AND. sij(il,i,j)<0.95) THEN
+                j>=(icb(il) - 1) .AND. j<=inb(il) .AND. &
+                lwork(il)) THEN
+
+          IF (sij(il, i, j)>1.0E-16 .AND. sij(il, i, j)<0.95) THEN
             wgh = 1.0
             IF (j>i) THEN
-              sjmax = max(sij(il,i,j+1), smax(il))
+              sjmax = max(sij(il, i, j + 1), smax(il))
               sjmax = amin1(sjmax, scrit(il))
-              smax(il) = max(sij(il,i,j), smax(il))
-              sjmin = max(sij(il,i,j-1), smax(il))
+              smax(il) = max(sij(il, i, j), smax(il))
+              sjmin = max(sij(il, i, j - 1), smax(il))
               sjmin = amin1(sjmin, scrit(il))
-              IF (sij(il,i,j)<(smax(il)-1.0E-16)) wgh = 0.0
-              smid = amin1(sij(il,i,j), scrit(il))
+              IF (sij(il, i, j)<(smax(il) - 1.0E-16)) wgh = 0.0
+              smid = amin1(sij(il, i, j), scrit(il))
             ELSE
-              sjmax = max(sij(il,i,j+1), scrit(il))
-              smid = max(sij(il,i,j), scrit(il))
+              sjmax = max(sij(il, i, j + 1), scrit(il))
+              smid = max(sij(il, i, j), scrit(il))
               sjmin = 0.0
-              IF (j>1) sjmin = sij(il, i, j-1)
+              IF (j>1) sjmin = sij(il, i, j - 1)
               sjmin = max(sjmin, scrit(il))
             END IF
-            delp = abs(sjmax-smid)
-            delm = abs(sjmin-smid)
-            asij(il) = asij(il) + wgh*(delp+delm)
-            ment(il, i, j) = ment(il, i, j)*(delp+delm)*wgh
+            delp = abs(sjmax - smid)
+            delm = abs(sjmin - smid)
+            asij(il) = asij(il) + wgh * (delp + delm)
+            ment(il, i, j) = ment(il, i, j) * (delp + delm) * wgh
           END IF
         END IF
       END DO
 
-175 END DO
+    175 END DO
 
     DO il = 1, ncum
       IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il)) THEN
         asij(il) = max(1.0E-16, asij(il))
-        asij(il) = 1.0/asij(il)
+        asij(il) = 1.0 / asij(il)
         asum(il, i) = 0.0
         bsum(il, i) = 0.0
@@ -2607,6 +2585,6 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il)) THEN
-          ment(il, i, j) = ment(il, i, j)*asij(il)
+                j>=(icb(il) - 1) .AND. j<=inb(il)) THEN
+          ment(il, i, j) = ment(il, i, j) * asij(il)
         END IF
       END DO
@@ -2616,7 +2594,7 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il)) THEN
+                j>=(icb(il) - 1) .AND. j<=inb(il)) THEN
           asum(il, i) = asum(il, i) + ment(il, i, j)
-          ment(il, i, j) = ment(il, i, j)*sig(il, j)
+          ment(il, i, j) = ment(il, i, j) * sig(il, j)
           bsum(il, i) = bsum(il, i) + ment(il, i, j)
         END IF
@@ -2626,6 +2604,6 @@
     DO il = 1, ncum
       IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il)) THEN
-        bsum(il, i) = max(bsum(il,i), 1.0E-16)
-        bsum(il, i) = 1.0/bsum(il, i)
+        bsum(il, i) = max(bsum(il, i), 1.0E-16)
+        bsum(il, i) = 1.0 / bsum(il, i)
       END IF
     END DO
@@ -2634,6 +2612,6 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il)) THEN
-          ment(il, i, j) = ment(il, i, j)*asum(il, i)*bsum(il, i)
+                j>=(icb(il) - 1) .AND. j<=inb(il)) THEN
+          ment(il, i, j) = ment(il, i, j) * asum(il, i) * bsum(il, i)
         END IF
       END DO
@@ -2643,5 +2621,5 @@
       DO il = 1, ncum
         IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
-            j>=(icb(il)-1) .AND. j<=inb(il)) THEN
+                j>=(icb(il) - 1) .AND. j<=inb(il)) THEN
           csum(il, i) = csum(il, i) + ment(il, i, j)
         END IF
@@ -2651,32 +2629,32 @@
     DO il = 1, ncum
       IF (i>=icb(il) .AND. i<=inb(il) .AND. lwork(il) .AND. &
-          csum(il,i)<m(il,i)) THEN
+              csum(il, i)<m(il, i)) THEN
         nent(il, i) = 0
         ment(il, i, i) = m(il, i)
-        qent(il, i, i) = qnk(il) - ep(il, i)*clw(il, i)
+        qent(il, i, i) = qnk(il) - ep(il, i) * clw(il, i)
         uent(il, i, i) = unk(il)
         vent(il, i, i) = vnk(il)
         elij(il, i, i) = clw(il, i)
-! MAF        sij(il,i,i)=1.0
+        ! MAF        sij(il,i,i)=1.0
         sij(il, i, i) = 0.0
       END IF
     END DO ! il
 
-!AC!      do j=1,ntra
-!AC!       do il=1,ncum
-!AC!        if ( i.ge.icb(il) .AND. i.le.inb(il) .AND. lwork(il)
-!AC!     :     .AND. csum(il,i).lt.m(il,i) ) THEN
-!AC!         traent(il,i,i,j)=tra(il,nk(il),j)
-!AC!        endif
-!AC!       enddo
-!AC!      enddo
-789 END DO
-
-! MAF: renormalisation de MENT
-  CALL zilch(zm, nloc*na)
+    !AC!      do j=1,ntra
+    !AC!       do il=1,ncum
+    !AC!        if ( i.ge.icb(il) .AND. i.le.inb(il) .AND. lwork(il)
+    !AC!     :     .AND. csum(il,i).lt.m(il,i) ) THEN
+    !AC!         traent(il,i,i,j)=tra(il,nk(il),j)
+    !AC!        endif
+    !AC!       enddo
+    !AC!      enddo
+  789 END DO
+
+  ! MAF: renormalisation de MENT
+  CALL zilch(zm, nloc * na)
   DO jm = 1, nl
     DO im = 1, nl
       DO il = 1, ncum
-        zm(il, im) = zm(il, im) + (1.-sij(il,im,jm))*ment(il, im, jm)
+        zm(il, im) = zm(il, im) + (1. - sij(il, im, jm)) * ment(il, im, jm)
       END DO
     END DO
@@ -2686,6 +2664,6 @@
     DO im = 1, nl
       DO il = 1, ncum
-        IF (zm(il,im)/=0.) THEN
-          ment(il, im, jm) = ment(il, im, jm)*m(il, im)/zm(il, im)
+        IF (zm(il, im)/=0.) THEN
+          ment(il, im, jm) = ment(il, im, jm) * m(il, im) / zm(il, im)
         END IF
       END DO
@@ -2702,64 +2680,61 @@
   END DO
 
-
 END SUBROUTINE cv3_mixing
 
 SUBROUTINE cv3_unsat(nloc, ncum, nd, na, ntra, icb, inb, iflag, &
-                     t, rr, rs, gz, u, v, tra, p, ph, &
-                     th, tv, lv, lf, cpn, ep, sigp, clw, frac_s, qpreca, frac_a, qta , &                       !!jygprl
-                     m, ment, elij, delt, plcl, coef_clos, &
-                     mp, rp, up, vp, trap, wt, water, evap, fondue, ice, &
-                     faci, b, sigd, &
-                     wdtrainA, wdtrainS, wdtrainM)                                      ! RomP
+        t, rr, rs, gz, u, v, tra, p, ph, &
+        th, tv, lv, lf, cpn, ep, sigp, clw, frac_s, qpreca, frac_a, qta, &                       !!jygprl
+        m, ment, elij, delt, plcl, coef_clos, &
+        mp, rp, up, vp, trap, wt, water, evap, fondue, ice, &
+        faci, b, sigd, &
+        wdtrainA, wdtrainS, wdtrainM)                                      ! RomP
   USE lmdz_print_control, ONLY: prt_level, lunout
   USE lmdz_nuage_params
   USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-
-  include "cvthermo.h"
-  include "cv3param.h"
-
-!inputs:
-  INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
-  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb
-  REAL, INTENT(IN)                                   :: delt
-  REAL, DIMENSION (nloc), INTENT (IN)                :: plcl
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, rs
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: gz
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: u, v
-  REAL, DIMENSION (nloc, nd, ntra), INTENT(IN)       :: tra
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
-  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: ep, sigp, clw   !adiab ascent shedding
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: frac_s          !ice fraction in adiab ascent shedding !!jygprl
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: qpreca          !adiab ascent precip                   !!jygprl
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: frac_a          !ice fraction in adiab ascent precip   !!jygprl
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: qta             !adiab ascent specific total water     !!jygprl
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: th, tv, lv, cpn
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf
-  REAL, DIMENSION (nloc, na), INTENT (IN)            :: m
-  REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: ment, elij
-  REAL, DIMENSION (nloc), INTENT (IN)                :: coef_clos
-
-!input/output
-  INTEGER, DIMENSION (nloc), INTENT (INOUT)          :: iflag(nloc)
-
-!outputs:
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: mp, rp, up, vp
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: water, evap, wt
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: ice, fondue
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: faci            ! ice fraction in precipitation
-  REAL, DIMENSION (nloc, na, ntra), INTENT (OUT)     :: trap
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: b
-  REAL, DIMENSION (nloc), INTENT (OUT)               :: sigd
-! 25/08/10 - RomP---- ajout des masses precipitantes ejectees
-! de l ascendance adiabatique et des flux melanges Pa et Pm.
-! Distinction des wdtrain
-! Pa = wdtrainA     Pm = wdtrainM
-  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: wdtrainA, wdtrainS, wdtrainM
-
-!local variables
+  !inputs:
+  INTEGER, INTENT (IN) :: ncum, nd, na, ntra, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: icb, inb
+  REAL, INTENT(IN) :: delt
+  REAL, DIMENSION (nloc), INTENT (IN) :: plcl
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t, rr, rs
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: gz
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: u, v
+  REAL, DIMENSION (nloc, nd, ntra), INTENT(IN) :: tra
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: p
+  REAL, DIMENSION (nloc, nd + 1), INTENT (IN) :: ph
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: ep, sigp, clw   !adiab ascent shedding
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: frac_s          !ice fraction in adiab ascent shedding !!jygprl
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: qpreca          !adiab ascent precip                   !!jygprl
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: frac_a          !ice fraction in adiab ascent precip   !!jygprl
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: qta             !adiab ascent specific total water     !!jygprl
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: th, tv, lv, cpn
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: lf
+  REAL, DIMENSION (nloc, na), INTENT (IN) :: m
+  REAL, DIMENSION (nloc, na, na), INTENT (IN) :: ment, elij
+  REAL, DIMENSION (nloc), INTENT (IN) :: coef_clos
+
+  !input/output
+  INTEGER, DIMENSION (nloc), INTENT (INOUT) :: iflag(nloc)
+
+  !outputs:
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: mp, rp, up, vp
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: water, evap, wt
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: ice, fondue
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: faci            ! ice fraction in precipitation
+  REAL, DIMENSION (nloc, na, ntra), INTENT (OUT) :: trap
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: b
+  REAL, DIMENSION (nloc), INTENT (OUT) :: sigd
+  ! 25/08/10 - RomP---- ajout des masses precipitantes ejectees
+  ! de l ascendance adiabatique et des flux melanges Pa et Pm.
+  ! Distinction des wdtrain
+  ! Pa = wdtrainA     Pm = wdtrainM
+  REAL, DIMENSION (nloc, na), INTENT (OUT) :: wdtrainA, wdtrainS, wdtrainM
+
+  !local variables
   INTEGER i, j, k, il, num1, ndp1
   REAL smallestreal
@@ -2770,40 +2745,40 @@
   REAL ampmax, thaw
   REAL tevap(nloc)
-  REAL, DIMENSION (nloc, na)      :: lvcp, lfcp
-  REAL, DIMENSION (nloc, na)      :: h, hm
-  REAL, DIMENSION (nloc, na)      :: ma
-  REAL, DIMENSION (nloc, na)      :: frac          ! ice fraction in precipitation source
-  REAL, DIMENSION (nloc, na)      :: fraci         ! provisionnal ice fraction in precipitation
-  REAL, DIMENSION (nloc, na)      :: prec
+  REAL, DIMENSION (nloc, na) :: lvcp, lfcp
+  REAL, DIMENSION (nloc, na) :: h, hm
+  REAL, DIMENSION (nloc, na) :: ma
+  REAL, DIMENSION (nloc, na) :: frac          ! ice fraction in precipitation source
+  REAL, DIMENSION (nloc, na) :: fraci         ! provisionnal ice fraction in precipitation
+  REAL, DIMENSION (nloc, na) :: prec
   REAL wdtrain(nloc)
   LOGICAL lwork(nloc), mplus(nloc)
 
 
-! ------------------------------------------------------
-IF (prt_level >= 10) print *,' ->cv3_unsat, iflag(1) ', iflag(1)
-
-smallestreal=tiny(smallestreal)
-
-! =============================
-! --- INITIALIZE OUTPUT ARRAYS 
-! =============================
-!  (loops up to nl+1)
-mp(:,:) = 0.
-rp(:,:) = 0.
-up(:,:) = 0.
-vp(:,:) = 0.
-water(:,:) = 0.
-evap(:,:) = 0.
-wt(:,:) = 0.
-ice(:,:) = 0.
-fondue(:,:) = 0.
-faci(:,:) = 0.
-b(:,:) = 0.
-sigd(:) = 0.
-!! RomP >>>
-wdtrainA(:,:) = 0.
-wdtrainS(:,:) = 0.
-wdtrainM(:,:) = 0.
-!! RomP <<<
+  ! ------------------------------------------------------
+  IF (prt_level >= 10) print *, ' ->cv3_unsat, iflag(1) ', iflag(1)
+
+  smallestreal = tiny(smallestreal)
+
+  ! =============================
+  ! --- INITIALIZE OUTPUT ARRAYS
+  ! =============================
+  !  (loops up to nl+1)
+  mp(:, :) = 0.
+  rp(:, :) = 0.
+  up(:, :) = 0.
+  vp(:, :) = 0.
+  water(:, :) = 0.
+  evap(:, :) = 0.
+  wt(:, :) = 0.
+  ice(:, :) = 0.
+  fondue(:, :) = 0.
+  faci(:, :) = 0.
+  b(:, :) = 0.
+  sigd(:) = 0.
+  !! RomP >>>
+  wdtrainA(:, :) = 0.
+  wdtrainS(:, :) = 0.
+  wdtrainM(:, :) = 0.
+  !! RomP <<<
 
   DO i = 1, nlp
@@ -2816,16 +2791,16 @@
   END DO
 
-! ***  Set the fractionnal area sigd of precipitating downdraughts
+  ! ***  Set the fractionnal area sigd of precipitating downdraughts
   DO il = 1, ncum
-    sigd(il) = sigdz*coef_clos(il)
-  END DO
-
-! =====================================================================
-! --- INITIALIZE VARIOUS ARRAYS AND PARAMETERS USED IN THE COMPUTATIONS
-! =====================================================================
-!  (loops up to nl+1)
-
-  delti = 1./delt
-  tinv = 1./3.
+    sigd(il) = sigdz * coef_clos(il)
+  END DO
+
+  ! =====================================================================
+  ! --- INITIALIZE VARIOUS ARRAYS AND PARAMETERS USED IN THE COMPUTATIONS
+  ! =====================================================================
+  !  (loops up to nl+1)
+
+  delti = 1. / delt
+  tinv = 1. / 3.
 
   DO i = 1, nlp
@@ -2834,69 +2809,68 @@
       fraci(il, i) = 0.0
       prec(il, i) = 0.0
-      lvcp(il, i) = lv(il, i)/cpn(il, i)
-      lfcp(il, i) = lf(il, i)/cpn(il, i)
-    END DO
-  END DO
-
-!AC!        do k=1,ntra
-!AC!         do i=1,nd
-!AC!          do il=1,ncum
-!AC!           trap(il,i,k)=tra(il,i,k)
-!AC!          enddo
-!AC!         enddo
-!AC!        enddo
-
-! ***  check whether ep(inb)=0, if so, skip precipitating    ***
-! ***             downdraft calculation                      ***
-
+      lvcp(il, i) = lv(il, i) / cpn(il, i)
+      lfcp(il, i) = lf(il, i) / cpn(il, i)
+    END DO
+  END DO
+
+  !AC!        do k=1,ntra
+  !AC!         do i=1,nd
+  !AC!          do il=1,ncum
+  !AC!           trap(il,i,k)=tra(il,i,k)
+  !AC!          enddo
+  !AC!         enddo
+  !AC!        enddo
+
+  ! ***  check whether ep(inb)=0, if so, skip precipitating    ***
+  ! ***             downdraft calculation                      ***
 
   DO il = 1, ncum
-!!          lwork(il)=.TRUE.
-!!          IF(ep(il,inb(il)).lt.0.0001)lwork(il)=.FALSE.
-!jyg<
-!!    lwork(il) = ep(il, inb(il)) >= 0.0001
+    !!          lwork(il)=.TRUE.
+    !!          IF(ep(il,inb(il)).lt.0.0001)lwork(il)=.FALSE.
+    !jyg<
+    !!    lwork(il) = ep(il, inb(il)) >= 0.0001
     lwork(il) = ep(il, inb(il)) >= 0.0001 .AND. iflag(il) <= 2
   END DO
 
-! Get adiabatic ascent mass flux 
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! Get adiabatic ascent mass flux
+
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   IF (adiab_ascent_mass_flux_depends_on_ejectliq) THEN
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!!! Warning : this option leads to water conservation violation
-!!!           Expert only
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!! Warning : this option leads to water conservation violation
+    !!!           Expert only
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     DO il = 1, ncum
       ma(il, nlp) = 0.
-      ma(il, 1)   = 0.
-    END DO
-
-  DO i = nl, 2, -1
+      ma(il, 1) = 0.
+    END DO
+
+    DO i = nl, 2, -1
       DO il = 1, ncum
-        ma(il, i) = ma(il, i+1)*(1.-qta(il,i))/(1.-qta(il,i-1)) + m(il, i)
+        ma(il, i) = ma(il, i + 1) * (1. - qta(il, i)) / (1. - qta(il, i - 1)) + m(il, i)
       END DO
-  END DO
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    END DO
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     DO il = 1, ncum
       ma(il, nlp) = 0.
-      ma(il, 1)   = 0.
-    END DO
-
-  DO i = nl, 2, -1
+      ma(il, 1) = 0.
+    END DO
+
+    DO i = nl, 2, -1
       DO il = 1, ncum
-        ma(il, i) = ma(il, i+1) + m(il, i)
+        ma(il, i) = ma(il, i + 1) + m(il, i)
       END DO
-  END DO
+    END DO
 
   ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-
-! ***                    begin downdraft loop                    ***
-
-! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
+  ! ***                    begin downdraft loop                    ***
+
+  ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
   DO i = nl + 1, 1, -1
@@ -2911,18 +2885,17 @@
 
 
-! ***  integrate liquid water equation to find condensed water   ***
-! ***                and condensed water flux                    ***
-
-
-! ***              calculate detrained precipitation             ***
-
-
-    DO il = 1, ncum                                                   
-      IF (i<=inb(il) .AND. lwork(il)) THEN                            
-        wdtrain(il) = grav*ep(il, i)*m(il, i)*clw(il, i)            
-        wdtrainS(il, i) = wdtrain(il)/grav                                            !   Ps   jyg
-!!        wdtrainA(il, i) = wdtrain(il)/grav                                          !   Ps   RomP
-      END IF                                                          
-    END DO                                                            
+    ! ***  integrate liquid water equation to find condensed water   ***
+    ! ***                and condensed water flux                    ***
+
+
+    ! ***              calculate detrained precipitation             ***
+
+    DO il = 1, ncum
+      IF (i<=inb(il) .AND. lwork(il)) THEN
+        wdtrain(il) = grav * ep(il, i) * m(il, i) * clw(il, i)
+        wdtrainS(il, i) = wdtrain(il) / grav                                            !   Ps   jyg
+        !!        wdtrainA(il, i) = wdtrain(il)/grav                                          !   Ps   RomP
+      END IF
+    END DO
 
     IF (i>1) THEN
@@ -2930,9 +2903,9 @@
         DO il = 1, ncum
           IF (i<=inb(il) .AND. lwork(il)) THEN
-            awat = elij(il, j, i) - (1.-ep(il,i))*clw(il, i)
+            awat = elij(il, j, i) - (1. - ep(il, i)) * clw(il, i)
             awat = max(awat, 0.0)
-            wdtrain(il) = wdtrain(il) + grav*awat*ment(il, j, i)
-            wdtrainM(il, i) = wdtrain(il)/grav - wdtrainS(il, i)    !   Pm  jyg
-!!            wdtrainM(il, i) = wdtrain(il)/grav - wdtrainA(il, i)  !   Pm  RomP
+            wdtrain(il) = wdtrain(il) + grav * awat * ment(il, j, i)
+            wdtrainM(il, i) = wdtrain(il) / grav - wdtrainS(il, i)    !   Pm  jyg
+            !!            wdtrainM(il, i) = wdtrain(il)/grav - wdtrainA(il, i)  !   Pm  RomP
           END IF
         END DO
